image: registry.gitlab.developers.cam.ac.uk/ch/co/wpkg/wpkg-ci-docker:latest

variables:
  GIT_DEPTH: 10

stages:
  - lint
  - cachecheck
  - functionalcheck

{% if data|length > 0 %}
{% for index in range(data|length) %}
wpkg_{{ data[index] }}:
  stage: functionalcheck
  variables:
    FF_SCRIPT_SECTIONS: "true"
    PKGID: {{ data[index] }}
    WPKGLOGDIR: "netinst\\logs"
    WPKGCMD: "cmd /c \\\\wpkg.ch.cam.ac.uk\\wpkg\\wpkg-dev-gitci.cmd gitci"
  tags:
    - windows
  image: mcr.microsoft.com/powershell:7.4-windowsserver-ltsc2022
  rules:
    - when: on_success
  artifacts:
    when: on_failure
    paths:
      - netinst\*.*
      - netinst\logs\*.*
  before_script:
    - Write-Output "$([char]27)[0Ksection_start:$(Get-Date -Format 's'):my_first_section[collapsed=true]$([char]13)$([char]27)[0KBefore-script"
    # Populate registry with the expected values
    - $a=New-Item -Path "Registry::HKEY_LOCAL_MACHINE\SOFTWARE\WPKG"
    - $a=New-Item -Path "Registry::HKEY_LOCAL_MACHINE\SOFTWARE\WPKG\vars"
    - $a=New-ItemProperty -Path "HKLM:\Software\WPKG\vars" -Name "SOFTWARE" -Value "\\wpkg.ch.cam.ac.uk\deploy$" -PropertyType String
    - $a=New-ItemProperty -Path "HKLM:\Software\WPKG\vars" -Name "WPKGINSTITUTION" -Value "Chemistry" -PropertyType String
    - $a=New-ItemProperty -Path "HKLM:\Software\WPKG\vars" -Name "WPKGJS" -Value "\\wpkg.ch.cam.ac.uk\wpkg\wpkg-rl201\wpkg.js" -PropertyType String
    - $a=New-ItemProperty -Path "HKLM:\Software\WPKG\vars" -Name "WPKGJS64" -Value "\\wpkg.ch.cam.ac.uk\wpkg\wpkg64-rl201.js" -PropertyType String
    - $a=New-ItemProperty -Path "HKLM:\Software\WPKG\vars" -Name "WPKGLOGDIR" -Value "$PWD\$Env:WPKGLOGDIR" -PropertyType String
    - $a=New-ItemProperty -Path "HKLM:\Software\WPKG\vars" -Name "WPKGSOFTWARE" -Value "\\ifs.ch.private.cam.ac.uk\deploy\software" -PropertyType String
    - $a=New-ItemProperty -Path "HKLM:\Software\WPKG\vars" -Name "WPKGSOFTWAREUSER" -Value "ad\chemistry-wpkg-share" -PropertyType String
    - $a=New-ItemProperty -Path "HKLM:\Software\WPKG\vars" -Name "WPKGSOFTWAREPASSWORD" -Value "$Env:WPKGPASSWORD" -PropertyType String
    - $a=New-ItemProperty -Path "HKLM:\Software\WPKG\vars" -Name "WPKGSHAREBASE" -Value "\\ifs.ch.private.cam.ac.uk\deploy" -PropertyType String
    - New-Item -ItemType Directory -Path $Env:WPKGLOGDIR -Force
    # Overwrite netsh to return success
    - takeown /f $Env:WinDir\system32\netsh.exe
    - icacls $Env:WinDir\system32\netsh.exe /T /C /grant administrators:F System:F everyone:F
    - cmd /c del /f $Env:WinDir\system32\netsh.exe
    - cmd /c echo echo "STUB netsh called" >$Env:WinDir\system32\netsh.cmd
    - Write-Output "$([char]27)[0Ksection_end:$(Get-Date -Format 's'):my_first_section$([char]13)$([char]27)[0K"
  script:
    - |
      Function Get-UnixTimeStamp () {
        $epoch = [timezone]::CurrentTimeZone.ToLocalTime([datetime]'1/1/1970')
        [int]((New-TimeSpan -Start $epoch -End (Get-Date)).TotalSeconds)
      }
      Write-Host "Debug";
      Write-Host "PWD $($PWD)";
      #Write-Host "WPKGLOGDIR $($Env:WPKGLOGDIR)";
      cmd /c reg query HKLM\Software\WPKG\vars
      Write-Host "Downloading status";
      try {
        $status=Invoke-RestMethod -Headers @{ "JOB-TOKEN"="$CI_JOB_TOKEN" } -uri "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/status/1.0.0/status.json" -Method GET -ContentType "application/json" | ConvertTo-Json | ConvertFrom-Json -AsHashTable
        Write-Host "Status downloaded";
      } catch {
        $status = @{}
        Write-Host "Status bootstrapped";
      }
      Write-Host "Beginning";
      $inf = @(cmd /c \\wpkg.ch.cam.ac.uk\wpkg\wpkg-dev-gitci.cmd gitci /show:$Env:PKGID);
      $aa=@{};
      foreach ($line in $inf) { 
        Write-Host ("Line {0}" -f $line)
        $parts = $line -Split ":", 2; 
        if ($parts.Length -eq 2) {
          $k=$parts[0].Trim();
          $v=$parts[1].Trim();
          $aa[$k]=$v;
        }
      };
      if ($aa.Status -ne 'Not Installed') {
        $m="Package something other than 'Not Installed': {0}" -f $aa["Status"];
        Write-Host $m;
        Exit 1;
      } else {
        Write-Host "Package confirmed not installed";
      };
      Write-Host "================== Installing $($Env:PKGID) ===============";
      $timeoutSeconds=3000;
      $cb={
        cmd /c \\wpkg.ch.cam.ac.uk\wpkg\wpkg-dev-gitci.cmd gitci /install:$Env:PKGID /quitonerror:true /debug:cmds;
      }
      $j=Start-Job -ScriptBlock $cb
      if (Wait-Job $j -Timeout $timeoutSeconds) { 
        Write-Host "Job completed";
        Receive-Job $j
      }
      Write-Host "CI Job timedout";
      Remove-Job -force $j
      Write-Host "================== Install ended ==========================";

      $inf = $(cmd /c \\wpkg.ch.cam.ac.uk\wpkg\wpkg-dev-gitci.cmd gitci /show:$Env:PKGID);
      $aa=@{};
      foreach ($line in $inf) {
        $parts = $line -Split ":", 2;
        if ($parts.Length -eq 2) {
          $k=$parts[0].Trim();
          $v=$parts[1].Trim();
          $aa[$k]=$v;
        }
      };
      if ($aa["Status"] -ne 'Installed') {
        Write-Host "Package could not be installed";
        Exit 1;
      } else {
        Write-Host "Package confirmed installed";
      };
      Write-Host "================== Removing $($Env:PKGID) =================";
      cmd /c \\wpkg.ch.cam.ac.uk\wpkg\wpkg-dev-gitci.cmd gitci /remove:$Env:PKGID;
      Write-Host "================== Removal ended ==========================";
      $inf = cmd /c \\wpkg.ch.cam.ac.uk\wpkg\wpkg-dev-gitci.cmd gitci /show:$Env:PKGID;
      $aa=@{};
      foreach ($line in $inf) {
        $parts = $line -Split ":", 2;
        if ($parts.Length -eq 2) {
          $k=$parts[0].Trim();
          $v=$parts[1].Trim();
          $aa[$k]=$v;
        }
      };
      if ($aa["Status"] -ne 'Not Installed') {
        Write-Host "Package could not be removed";
        Exit 1
      } else {
        Write-Host "Package confirmed removed";
      };
      # Find the right file
      # Get all XML files in the packages directory
      $xmlFiles = Get-ChildItem -Path .\packages -Filter *.xml 
      # Loop through each XML file
      $myfile=''
      Write-Host "Searching files for $($Env:PKGID)"
      foreach ($file in $xmlFiles) {
        # Write-Host "Examining $($file.FullName)"
        # Load XML content
        try {
          $xmlContent = [xml](Get-Content $file.FullName)

          # Search for the package entity with id equal to 'weka'
          $packageNode = $xmlContent.SelectNodes("//package[@id='$($Env:PKGID)']")

          # If the package entity is found, print the file name and break the loop
          if ($packageNode.Count -gt 0) {
              $myfile=$file.FullName
              Write-Host "Found in file: $($file.FullName)"
              break
          }
        } catch {
          Write-Host "Something failed with $($file.FullName)"
        }
      }
      Write-Host "Getting latest copy of status from repository"
      try {
        $status=Invoke-RestMethod -Headers @{ "JOB-TOKEN"="$CI_JOB_TOKEN" } -uri "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/status/1.0.0/status.json" -Method GET -ContentType "application/json" | ConvertTo-Json | ConvertFrom-Json -AsHashTable
        Write-Host "Status downloaded";
      } catch {
        $status = @{}
        Write-Host "Status bootstrapped";
      }
      if ($myfile -eq '') {
        Write-Host "Could not find XML file"
        Exit 2
      } else {
        $md5=(get-Filehash -Path $myfile -Algorithm 'MD5').Hash.ToLower()
        Write-Host "MD5 $($md5)"
        $status[$Env:PKGID]=@{"testdate"=Get-UnixTimeStamp;"md5"=(get-Filehash -Path $myfile -Algorithm 'MD5').Hash.ToLower()}
      }
      # Write-Host $status.
      Invoke-RestMethod -Headers @{ "JOB-TOKEN"="$CI_JOB_TOKEN" }  -Body ($status | ConvertTo-Json) -uri "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/status/1.0.0/status.json" -Method PUT -ContentType "application/json"
{% endfor %}
{% else %}
# No-op CI here.
wpkg_noop:
  stage: functionalcheck
  rules:
    - when: on_success
  script: 
   - |
     true

{% endif %}
